--Build terrain
local tmap,ts={0,0,0,0},2
for iter=1,10 do
	local rnd=11-iter
	local nts={}
	for y=1,ts-1 do
		local rs=(y-1)*ts
		local inr={}
		for x=1,ts-1 do		
			local nh=tmap[x+rs]+tmap[x+1+rs]+tmap[x+rs+ts]+tmap[x+1+rs+ts]
			local nr=(math.random(rnd)-1-rnd/2)/iter
			table.insert(inr,nr)
			table.insert(nts,tmap[x+rs])
			table.insert(nts,(tmap[x+rs]+tmap[x+1+rs])/2+nr/2)
		end
		table.insert(nts,tmap[ts+rs])
		for x=1,ts-1 do
			local nr=inr[x]
			table.insert(nts,(tmap[x+rs]+tmap[x+rs+ts])/2+nr/2)
			table.insert(nts,(tmap[x+rs]+tmap[x+1+rs+ts])/2+nr)
		end
		table.insert(nts,tmap[ts+rs])		
	end
	local rs=(ts-1)*ts
	for x=1,ts-1 do
		table.insert(nts,tmap[x+rs])
		table.insert(nts,(tmap[x+rs]+tmap[x+1+rs])/2)
	end	
	table.insert(nts,tmap[ts+rs])		
	tmap=nts
	ts=ts+1
print(#tmap,ts)
end

local mw=math.sqrt(#tmap)
local f={}
for y=1,mw-1 do
	for x=1,mw-1 do
		local ari={}
		table.insert(ari,{v=x+(y-1)*mw,t=x+(y-1)*mw})
		table.insert(ari,{v=x+(y-1)*mw+1,t=x+(y-1)*mw+1})
		table.insert(ari,{v=x+y*mw+1,t=x+y*mw+1})
		table.insert(f,ari)
		ari={}
		table.insert(ari,{v=x+(y-1)*mw,t=x+(y-1)*mw})
		table.insert(ari,{v=x+y*mw+1,t=x+y*mw+1})
		table.insert(ari,{v=x+y*mw,t=x+y*mw})
		table.insert(f,ari)		
	end
end
local arv={}
local art={}
for y=1,mw do
	for x=1,mw do	
		table.insert(arv,x/mw-0.5)
		table.insert(arv,tmap[x+(y-1)*mw]/2)
		table.insert(arv,y/mw-0.5)
		table.insert(art,x/mw)
		table.insert(art,y/mw)
	end
end
local mter=G3DFormat.mapCoords(arv,art,{},f)
mter.type="mesh"

G3DFormat.computeG3DSizes(mter)
local obj=G3DFormat.buildG3D(mter)

local scrw,scrh=application:getContentWidth(),application:getContentHeight()
local view=Viewport.new()
local vp=Matrix.new()
vp:perspectiveProjection(45,-scrw/scrh,0.01,1000)
view:setProjection(vp)
view:setPosition(scrw/2,scrh/2)
view:setScale(scrw/2,scrh/2,1)

Lighting.apply(obj)
local mix,miy,miz,max,may,maz=obj.min[1],obj.min[2],obj.min[3],obj.max[1],obj.max[2],obj.max[3]
local cx,cy,cz=(mix+max)/2,(miy+may)/2,(miz+maz)/2
local ex,ey,ez=max-mix,may+miy,maz-miz
local em=math.max(ex,ey,ez)
local cnt=Sprite.new()

view:setContent(cnt)
--print(mix,miy,miz,max,may,maz)
--print(em,cx,cy,cz)
local rad=em*2

view:lookAt(0,1,0,0,0,0,0,0,1)
local lx,ly,lz=view:getTransform():transformPoint(0,-0.5,0)
Lighting.setLight(lx,ly,lz,0.5)

stage:addChild(view)

--Scene
local ground_sz=em*100
local ground=Pixel.new(0x008000,1,ground_sz,ground_sz)
ground:setPosition(-ground_sz/2,0,-ground_sz/2)
ground:setRotationX(90)
cnt:addChild(ground)

cnt:addChild(obj)

Lighting.setSpecular(0.3,0.3,0.3,128)

stage:addEventListener(Event.MOUSE_MOVE,function (e)
	local sx=(e.x-(scrw/2))/scrw
	local sy=(e.y-(scrh/2))/scrw
local lx,ly,lz=view:getTransform():transformPoint(-sx,-0.4,-sy)
Lighting.setLight(lx,ly,lz,0.5)
end)
